import java.util.Arrays;

/*
Lesen Sie die Aufgaben genau durch.
Schreiben bzw. vervollständigen Sie gekennzeichnete Programmteile wie in den Kommentaren beschrieben.
Verändern Sie aber nicht vorgegebene Methodenköpfe oder andere vorgegebene Programmteile!
*/
public class SimpleArray {

    /*
    Aufgabe: Manipulation von einfachen Arrays mit elementarem Elementtyp.

        Ergänzen Sie fehlende Teile dieser Klasse entsprechend den Kommentaren
        an den mit TODO gekennzeichneten Stellen.
        Sonstige Anforderungen: Die Verwendung der Klasse 'String' oder 'StringBuffer'
        ist nicht erlaubt. Es sollen keine zusätzlichen Methoden implementiert werden.
        Hinweis: Die beiden gefragten Methoden funktionieren ähnlich. Sie dürfen sich
        daher gegenseitig aufrufen, oder auch unabhängig implementiert werden.

    Punkte (maximal 18):
        9 Punkte für die Implementierung von 'shiftLeft',
        9 Punkte für die Implementierung von 'shiftLeftMutating'.
        Bewertung: für jede Methode jeweils ALLES ODER NICHTS!
        nur vollständig, korrekt implementierte Methoden erhalten Punkte.
    */

    // verschiebt alle Elemente im Array um eine Stelle zurück;
    // das Element mit dem Index 0 wird an die freiwerdende
    // Stelle mit dem höchsten Index geschrieben;
    // wenn die Länge des Arrays kleiner als 2 ist, ist das Ergebnis
    // ein unverändertes Array;
    // das angegebene Array wird nicht verändert. Stattdessen
    // wird das Ergebnis als neues Array zurückgeliefert;
    // liefert null, wenn null übergeben wird;
    // Beispiel:
    // ein Aufruf mit array: {1,2,3,4}
    // liefert als Ergebnis folgendes Array:
    //                       {2,3,4,1};
    // array bleibt unverändert {1,2,3,4}.
    public static int[] shiftLeft(int[] array) {
        if (array.length<2){
            return array;
        }
        int [] shifted = new int[array.length];
        for(int i = 0; i<array.length;i++) {
            if (i+1 == array.length) {
                shifted[array.length - 1] = array[0];
            } else {
                shifted[i] = array[i + 1];
            }
        }
        return shifted;

    }

    // macht dasselbe wie shiftLeft mit dem Unterschied,
    // dass das angegebene Array verändert wird
    // (Methode mit Seiteneffekt);
    // Beispiel:
    // ein Aufruf mit array: {1,2,3,4}
    // ändert das angegebene Array wie folgt:
    //                       {2,3,4,1};
    // Vorbedingung: array != null
    public static void shiftLeftMutating(int[] array) {
        if(array != null){
            int [] help = shiftLeft(array);
            for(int i = 0; i<array.length;i++){
                array[i] = help[i];
            }
        }
    }


    // Diese Methode können Sie zum Testen nutzen. Geht nicht in die Beurteilung ein.
    public static void main(String[] args) {

        //Testen von shiftLeftMutating:
        int[] array = new int[]{1,2,3};
        shiftLeftMutating(array);
        System.out.println(Arrays.toString(array)); //[2, 3, 1]

        array = new int[]{2};
        shiftLeftMutating(array);
        System.out.println(Arrays.toString(array)); //[2]

        array = new int[]{};
        shiftLeftMutating(array);
        System.out.println(Arrays.toString(array)); //[]


        //Testen von shiftLeft:
        //...
        int[] test = new int[]{1,2,3,4,5};
        System.out.println(Arrays.toString(shiftLeft(test)));

    }
}

